module fft_work
!
!     (c) Copyright 1991 to 1998 by Michael A. Beer, William D. Dorland, 
!     P. B. Snyder, Q. P. Liu, and Gregory W. Hammett. ALL RIGHTS RESERVED.
!     
  ! ccfft
  !   UNICOS:
  !    table(100 + 8*n)
  !    work(8*n)
  !   UNICOS/mk:
  !    table(2*n)
  !    work(4*n)
  !   Origin:
  !    table(30 + 2*n)
  !    work(2*n)

  integer, parameter :: ccfft_table0 = 0
  integer, parameter :: ccfft_table1 = 2
  integer, parameter :: ccfft_work0 = 0
  integer, parameter :: ccfft_work1 = 4

  ! csfft/scfft
  !   UNICOS:
  !    table(100 + 4*n)
  !    work(4 + 4*n)
  !   UNICOS/mk:
  !    table(2*n)
  !    work(2*n)
  !   Origin:
  !    table(15 + n)
  !    work(n)

  integer, parameter :: csfft_table0 = 0
  integer, parameter :: csfft_table1 = 2
  integer, parameter :: csfft_work0 = 0
  integer, parameter :: csfft_work1 = 2

  interface
     subroutine ccfft(i,n,scale,x,y,table,work,isys)
       integer :: i, n, isys
       real :: scale
       complex, dimension(n) :: x, y
       real, dimension(*) :: table
       real, dimension(*) :: work
     end subroutine ccfft
  end interface

  interface
     subroutine csfft(i,n,scale,x,y,table,work,isys)
       integer :: i, n, isys
       real :: scale
       complex, dimension(n/2+1) :: x
       real, dimension(n) :: y
       real, dimension(*) :: table
       real, dimension(*) :: work
     end subroutine csfft
  end interface

  interface
     subroutine scfft(i,n,scale,x,y,table,work,isys)
       integer :: i, n, isys
       real :: scale
       complex, dimension(n/2+1) :: y
       real, dimension(n) :: x
       real, dimension(*) :: table
       real, dimension(*) :: work
     end subroutine scfft
  end interface
 
end module fft_work
