module io
!
!     (c) Copyright 1991 to 1998 by Michael A. Beer, William D. Dorland, 
!     P. B. Snyder, Q. P. Liu, and Gregory W. Hammett. ALL RIGHTS RESERVED.
!     

! Input/output routines for gryffin codes

  use io_ascii
  use io_binary
  use io_netcdf
  implicit none

!
! List of routines: 
! 
! wread       ! Read  gryffin .res file
! wpunch      ! Write gryffin .res file
! wreadnc     ! Read  gryffin .nc file
! wpunchnc    ! Write gryffin .nc file
! bwread      ! Read  gryffin .res file (unformatted) 
! bwpunch     ! Write gryffin .res file (unformatted) 

! input files:
!
! 12 RUNNAME.in     main namelist input file to control the run.
!  5 RUNNAME.resp   a copy of itg.res to continue from a previous run.
!
! output files:
!
!  7 RUNNAME.res    a complete dump of the common blocks.
!  9 RUNNAME.out    printout of various results
! 20 RUNNAME.fields phi(x,y) for particle code.
!
! **************************************************************

end module io



