program itgc
!
!     (c) Copyright 1991 to 1998 by Michael A. Beer, William D. Dorland, 
!     P. B. Snyder, Q. P. Liu, and Gregory W. Hammett. ALL RIGHTS RESERVED.
!     
  use mp, only: init_mp, finish_mp
  implicit none

  integer icontrol(2)

! Initialize MPI
  call init_mp

! Set up for normal execution
  icontrol(1)=0
  icontrol(2)=0

! Run the main code
  call itg(icontrol)

! Save the results
  call save

! Finish MPI
  call finish_mp

! on unicos cray, stop prints out CPU time summary.
  stop         

contains

  subroutine save

    use mp, only: proc0, iproc, barrier
    use itg_data, only: binary, ascii, cdf, runname, lrunname
    use io

    include 'netcdf.inc'
    integer ntim,ntimr
    real tim, dt1

  ! netcdf variables
    integer ncid,status
    character filename*80
    character yorn*1

  ! Save the results to the *.res, *.resb, or *.nc file:
    ntim=0
    ntimr=0
    if(binary) then
       filename=runname(1:lrunname)//'.bres'
       call bwpunch(filename,ntim,ntimr,tim,dt1)
    endif
    
    if(ascii) then
       filename=runname(1:lrunname)//'.bres'
       call wpunch(filename,ntim,ntimr,tim,dt1)
    endif
    
    if(cdf) then
       filename=runname(1:lrunname)//'.nc'
       call wpunchnc(filename,ntim,ntimr,tim,dt1)
    endif

  end subroutine save
end program itgc
